/* 
 *   Rotate.java
 *   
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class Rotate extends Applet implements ActionListener
{
  // create an instance of the canvas class below
  Drawarea drawing = new Drawarea ( );
  Panel controls = new Panel ( ); 
  Panel first = new Panel ( );
  Panel second = new Panel ( );
  Panel third = new Panel ( );

  // buttons for the user to start and stop the animation
  Button pause, resume;
  
  // add variables for additional panels and components go here
  Color ltblue = new Color ( 153, 204, 255 );

  public void init ( ) 
  {  
    // first panel is empty
    // second panel is empty
    // create third panel with pause and resume buttons
    pause= new Button ( "Pause" );
    pause.addActionListener ( this );
    third.add ( pause );
    resume = new Button ( "Resume" );
    resume.addActionListener ( this );
    third.add ( resume );
    
   //  create the control panel
    controls.setLayout ( new GridLayout ( 1, 1 ));
    // controls.add ( first );
    // controls.add ( second );
    controls.add ( third );
    controls.setBackground ( ltblue );

   // set the layout and contents of the whole applet   
    setLayout ( new BorderLayout ( ) );
    add ( drawing, BorderLayout.CENTER );
    add ( controls, BorderLayout.SOUTH );
   }

// the following three methods can be used without changes to start and
// stop the thread of the canvas, and to paint the canvas 
    // the applet start method
    public void start() 
    {  drawing.start ( );
     }
  
    // the applet stop method 
    public void stop( ) 
    {  drawing.stop ( );
     }
     
    // the applet paint method
    public void paint ( Graphics g ) 
    {  drawing.paint ( g );
     }
  
    // method to respond to action events
    public void actionPerformed ( ActionEvent event )
    {
       // respond to other buttons here. 

      // respond to pause button by calling the thread suspend method
      if ( event.getSource ( ) == pause )
         {  drawing.thread.suspend ( ) ;  }
         
      // respond to resume button by calling the thread resume method
      if ( event.getSource ( ) == resume )
      {  drawing.thread.resume ( ) ; }
   }   
}  // end of applet

class Drawarea extends Canvas implements Runnable
{
  // variables declarations
   Color purple = new Color ( 127, 0, 255 );

  // include these variables without change
  Thread thread;     
  Image buffer;      
  Graphics gbuffer; 
  
  public Drawarea ( )
  {
  // initialization (except for values that depend on the size of the canvas)
   setBackground ( Color.black );
    }
 
// use these two methods without change 
   public void start() 
   {   // create a thread and start it running
       if ( thread == null ) 
           { thread = new Thread( this );
              thread.start();
            }
    }
  
   public void stop() 
   {  // stop the thread from running and destroy it
       if ( thread != null ) 
          { thread.stop();
             thread = null;
           }
    }
   
  // this run method is what the thread executes
   public void run() 
   { // continuous loop
      while ( thread != null ) 
      {
         repaint();
         try 
             // wait for 50 milliseconds before continuing to repaint
             { Thread.sleep(50);
              } catch ( InterruptedException e ) {   };    
       }
    }
  
// give an update that does not blank out background (removing flicker)
   public void update (Graphics g)
   { paint (g);
   }
    
  public void paint ( Graphics g ) 
  {  
  // the first time, do initialization that depends on the size of the canvas
     if ( buffer == null )
     {      
        // Create an off-screen image for double buffering:
        buffer = createImage( getSize( ).width, getSize( ).height );
        // Get off-screen graphics context:
        gbuffer = buffer.getGraphics(); 
        // draw background 
        gbuffer.setColor ( getBackground ( ) );
        gbuffer.fillRect ( 0, 0,  getSize( ).width , getSize( ).height );
     }
     //  all drawing should take place on gbuffer
     // draw everything using gbuffer here, including setColor

         
     // draw the buffer in the canvas drawarea by using graphics g
     // this makes the drawing appear in the applet all at once
     g.drawImage( buffer, 0, 0, this );
  }
}
