/*   MadLib.java
 *   Prompts the user to type in words and generates a madlib
 */

import java.awt.*;
import java.awt.event.*;

public class MadLib extends java.applet.Applet
	                	implements ActionListener
{
   Button firstmadlib, clearbutton;
   Label prompt1,prompt2;
   TextField input1, input2 ;
   TextArea output ;
   Font medfont = new Font ("SansSerif", Font.PLAIN, 18 );

/*  This method is called once when the applet is downloaded, and
 *   defines the Labels, TextFields, Buttons and TextArea that initially
 *  appear in the applet area.
 */
   public void init ( )
   {  //   set applet properties 
      setBackground ( Color.white );
      setFont ( medfont );
      
      //  add labels and textfields (without events)
      prompt1 = new Label ( "Enter a noun:  ")  ;
      add ( prompt1 ) ;

      input1 = new TextField ( 20 ) ;
      add ( input1 ) ;
      
      prompt2 = new Label ( "Enter a verb: ");
      add ( prompt2 ) ;
      
      input2 = new TextField ( 20 ) ;
      add ( input2 );

     // add two buttons *with* events
      firstmadlib = new Button ( "First Mad Lib");
      firstmadlib.addActionListener  ( this ) ;
      add ( firstmadlib ) ;
      
      clearbutton = new Button ( "       Clear       " ) ;
      clearbutton.addActionListener ( this ) ;
      add ( clearbutton ) ;
      
      output = new TextArea ( 5, 40 );  // 5 lines of 40 character each
      output.setEditable ( false ) ;        // don't allow users to type in area
      add ( output ) ;
   }

/*  This method is called by the browser whenever a Button is clicked.
 *  It uses the event argument to determine which Button it was, and defines
 *        what to do in response.
 */
   public void actionPerformed (ActionEvent event)
   {  
      String silly1, silly2, silly3, word1, word2;
      
      if ( event.getSource ( ) == firstmadlib ) 
      {  // define the mad lib strings.  use \n for end-of-line
          silly1 = "I was hunched over my computer, \n madly typing, when I saw a black " ;
          silly2 = "\n come in the window and  ";
          silly3 = " out the door.  \nI said, I must need more Java!";
          
          // read the words that the user typed into the TextFields
          word1 = input1.getText ( ) ;
          word2 = input2.getText ( ) ;

         // use the + catenation operator to put the strings together into the TextArea
         output.setText ( silly1 + word1 + silly2 + word2 + silly3 );
         }
         
         if ( event.getSource ( ) == clearbutton )
         {  // delete the words from the TextFields and TextArea
            input1.setText ( "" ) ;
            input2.setText ( "" ) ;
            output.setText ( "" ) ;
           }
   }  
}
      


