/*  
 *  Magic.java
 *   This applet lets the user try to find a magic square:
 *    a 3 by 3 square with the digits 1 through 9 placed exactly once,
 *    and where every row, column, and diagonal add up to 15.
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class Magic extends Applet 
			implements ActionListener
{
  Font f = new Font("Dialog", Font.BOLD,18);
  Font f2 = new Font("Dialog", Font.BOLD,14);
  Color purple = new Color(127, 0, 255);
  
  Panel top = new Panel ( ) ;
  Panel board = new Panel ( ) ;
 
  Button reset = new Button("Reset");
  Button check = new Button ( "Check my answer");
  Label result = new Label ( "Result:         ");
 
  /*  digits is the array of buttons, digitvalues is an array
   *  which saves the number which labels each button
   */ 
  TextField digits [ ] = new TextField [9];
  int digitvalues [ ] = new int [9];
  
  public void init() 
  { 
   setBackground ( purple );

    board.setLayout(new GridLayout ( 3, 3, 5, 5));
    
    // create the textfields, add them to the board
    for (int i=0; i<digits.length; i++)
      { digits[i] = new TextField ( 1 );
        digitvalues[i] = 0 ; 
        digits[i].setFont(f);
        board.add (digits[i]);
      }

    reset.setFont ( f2 );
    reset.addActionListener ( this );
    top.add (reset );
    
    check.setFont ( f2 );
    check.addActionListener ( this );
    top.add (check );

    result.setFont ( f );
    top.add ( result );

    setLayout ( new BorderLayout ( ) );     
    add (top, BorderLayout.NORTH);
    add (board, BorderLayout.CENTER);
  }
  
  public void actionPerformed(ActionEvent e) 
  {
    // if player clicks check, check the answer
      if (e.getSource ( ) == check )
      {  
          for { int i = 0; i < digits.length ; i++ )
          { digitvalues [ i ] = Integer.parseInt ( digits [ i ].getText ( )) ; }
          
               win = checkwin ( );
               if ( win ) 
               {  result.setText ( "Result:  YES! ");
                }
                else 
                { result.setText ( "Result:  Sorry!")
                 }
             }
         }

// if the player clicks the reset button, set all the variables back to the beginning
    if (e.getSource ( ) == reset)
      {  
          for (int i=0; i<digits.length; i++)
                   { digits[i].setText ( " "); digitvalues[i] = " "; }
          result.setText ("Result:       ");
      }
  }
  
/* This is a method that checks the board to see if that every row,
 * column, and diagonal adds up to 15.
 */
  boolean checkwin ( ) 
  { 
    if  ( ((digitvalues [ 0 ] + digitvalues [ 1 ]  + digitvalues [ 2 ]  ) == 15 ) &&
          (( digitvalues [ 3 ] + digitvalues [ 4 ] + digitvalues [ 5 ] ) == 15 )  &&
          (( digitvalues [ 6 ] + digitvalues [ 7 ] + digitvalues [ 8 ] ) == 15 )  &&
          (( digitvalues [ 0 ] + digitvalues [ 3 ] + digitvalues [ 6 ] ) == 15 )  &&
          (( digitvalues [ 1 ] + digitvalues [ 4 ] + digitvalues [ 7 ] ) == 15 )  &&
          (( digitvalues [ 2 ] + digitvalues [ 5 ] + digitvalues [ 8 ] ) == 15 )  &&
          (( digitvalues [ 0 ] + digitvalues [ 4 ] + digitvalues [ 8 ] ) == 15 )  &&
          (( digitvalues [ 2 ] + digitvalues [ 4 ] + digitvalues [ 6 ] ) == 15 )  )
       { return true; }
     else
         {  return false; }
    }
}

