/*  DicePaint.java 
 *  This is a version of the Display Dice program, rolling
 *     the die in the paint method of the applet
 */ 
  
import java.awt.*; 
 
public class DicePaint extends java.applet.Applet 
{  
  /* all variables declared at the top of the applet can be used
   *   in all the methods
   */ 
  int face; 
  int frequency [ ] = new int [ 7]; 
  int MAX = 1000;    // number of times to roll the die 
 
  /*  This method is called once by the browser each time the applet is downloaded  
   *  In this version, there is nothing to do here.
   */ 
  public void init ( ) 
  {  
   } 

  /* This method is called by the browser each time it needs to paint
   *  the window.  This can be the first time it is displayed, or 
   *  whenever the window was covered up or minimized and needs to
   *  be painted again.
   *  In this version, the random numbers are generated here, so each
   *  time the window is painted, there are new random numbers.
   */
  public void paint (Graphics g) 
  { 
    Font bigfont = new Font ( "Serif", Font.BOLD, 24 ) ; 
    Font mediumfont = new Font ( " Serif ", Font.PLAIN, 18 ) ;  
    Color purple = new Color ( 127, 0, 255 );

    String  histlabel = "Frequency of rolls for each face of the die" ; 
    String  scalelabel = "Each pixel represents 1 roll of the die.  Total of "  + MAX + " rolls."; 

    // Roll the die here, but first reset to zero
    for ( int i=1; i < frequency.length;  i ++ ) 
	{ frequency [ i ] = 0; }

    for ( int i=1; i <= MAX;  i ++ ) 
     { 
       face = 1 + (int) (Math.random() * 6);   // random number between 1 and 6 
       frequency [ face ] ++ ; 
      } 
     
    setBackground(Color.white); 
    g.setFont ( bigfont ) ;  
    g.drawString ( histlabel, 10, 30 ) ; 
    g.setFont ( mediumfont ) ; 
    g.drawString ( scalelabel, 20, 50 ) ; 
     
    int start = 80 ;    // y value to start histogram 
    int line = 20 ;     //  no of pixels in each line of the histogram 
    int ystart;    //  for each line of histogram, the y value of upper corner 
    g.setColor ( purple ); 
     
    for ( int i = 1;  i < frequency.length; i ++ ) 
    {  
        ystart = start + (i-1) * line ; 
        g.drawString ( String.valueOf ( i ), 10,  ystart + 13 ); 
        g.fillRect ( 30, ystart, frequency [ i ], 10 ); 
    } 
  } 
} 
