/*  DisplayDice.java
 *  An applet to roll a die for a number of tries, storing the number
 *  of times each face is rolled in an array.  Then it displays a 
 *  histogram of the number of times each face is rolled.
 */
 
import java.awt.*;

public class DisplayDice extends java.applet.Applet
{ 
  // the frequency array will be used to store the frequency of rolls of the
  //  die for faces from 1 to 6 (note that the 0 index is not used).
  int face;
  int frequency [ ] = new int [ 7];
  int MAX = 1000;    // number of times to roll the die

  /*  This method is called once by the browser each time the applet is downloaded 
    *  Calls method Math.random to generate real random numbers between 0 and 1,
    *          scales them to "faces" between 1 and 6, and converts to an int
     */
  public void init ( )
  { 
      for ( int i=1; i <= MAX;  i ++ )
       {
         face = 1 + (int) (Math.random() * 6);   // random number between 1 and 6
         frequency [ face ] ++ ;
         }
     }
     
  public void paint (Graphics g)
  {
    Font bigfont = new Font ( "Serif", Font.BOLD, 24 ) ;
    Font mediumfont = new Font ( " Serif ", Font.PLAIN, 18 ) ; 
  
    String  histlabel = "Frequency of rolls for each face of the die" ;
    String  scalelabel = "Each pixel represents 1 roll of the die.  Total of "  + MAX + " rolls.";
    
    setBackground(Color.white);
    g.setFont ( bigfont ) ; 
    g.drawString ( histlabel, 10, 30 ) ;
    g.setFont ( mediumfont ) ;
    g.drawString ( scalelabel, 20, 50 ) ;
    
    int start = 80 ;       // y value to start histogram
    int line = 20 ;        //  no of pixels in each line of the histogram
    int ystart;              //  for each line of histogram, the y value of upper corner
    g.setColor ( Color.blue );
    
    for ( int i = 1;  i < frequency.length; i ++ )
    { 
        ystart = start + (i-1) * line ;
        g.drawString ( String.valueOf ( i ), 10,  ystart + 13 );
        g.fillRect ( 30, ystart, frequency [ i ], 10 );
    }
  }
}
