/*  RollDie.java
 *  An applet to roll a die for a number of tries, storing the number
 *  of times each face is rolled in an array.  Then it displays a 
 *  histogram of the number of times each face is rolled.
 */
 
import java.awt.*;

public class RollDie extends java.applet.Applet
{ 
  Font f = new Font("TimesRoman", Font.PLAIN, 24);
  
  // the frequency array will be used to store the frequency of rolls of the
  //  die for faces from 1 to 6 (note that the 0 index is not used).
  int face;
  int frequency [ ] = new int [ 7];
  static final int MAX = 1000;    // number of times to roll the die

  public void init ( )
  { 
    /* Use random to generate real random numbers between 0 and 1,
               and scale them to "faces" between 1 and 6 */
     for ( int i=1; i<=MAX;  i ++ )
       {
         face = 1 + (int) (Math.random() * 6);
         ++frequency [ face ];
         }
     }
     
  public void paint (Graphics g)
  {
    String  histlabel = "Frequency of rolls for each face of the die";
    
    setBackground(Color.white);
    g.setFont(f);
    
    g.drawString ( histlabel, 10, 30 );
    
    int start = 60;
    int line = 20;
    int ystart;
    
    g.setColor ( Color.blue );
    for ( int i = 1;  i < frequency.length; i ++ )
    { ystart = start + (i-1) * line ;
    g.drawString ( String.valueOf ( i ), 10,  ystart );
    g.fillRect ( 27, ystart - 13, frequency [ i ], 10 );
    }
  }
}
