/*  DisplayPoll.java  
 *  This applet displays previously recorded data for an opinion poll question  
 */  
   
import java.awt.*;  
  
public class DisplayPoll extends java.applet.Applet  
{   
  //  each answer has no. of votes, percent of votes, label of answer
  int numanswers = 4;  
  int votes [ ] = new int [ numanswers ];  
  int percents [ ] = new int [ numanswers ] ;  
  String answerlabels [ ] = new String [ numanswers ] ;  
  int totalvotes;  
  String questionline1, questionline2, sourcelabel ;  
  String whichdisplay = "votes";   // whether to display votes or percents  
  double scalevotes;               // scaling display of votes in pixels
    
  /*  This method is called once by the browser each time the applet is downloaded   
   *  Here we define the question, answers, and no. of votes and 
   *  we compute the total votes, the percents and the scalefactor.
   */  
  public void init ( )  
  {   
     questionline1 = "Lauryn Hill won this year's Grammy for best new artist. ";  
     questionline2 = "Surprised by this choice?";  
     answerlabels [ 0 ] = "Not at all, but I'm pleased.";  
     answerlabels [ 1 ] = "Yes!  but I'm pleased.";  
     answerlabels [ 2 ] = "No, but I'm disappointed.";   
     answerlabels [ 3 ] = "I didn't see that coming!  Why her??";  
     sourcelabel = "www.cnn.com/POLL/results/103381.html" ;  
       
      votes [ 0 ] = 900;  
      votes [ 1 ] = 344;  
      votes [ 2 ] = 472;  
      votes [ 3 ] = 595;  
  
     totalvotes = 0;  
     for ( int i = 0; i < numanswers;  i ++ )  
       {   
         // sum the votes to get the total  
         totalvotes = totalvotes + votes [ i ] ;  
         }  
           
     for ( int i = 0; i < numanswers;  i ++ )  
       {  
        // compute fraction of totalvotes as a double, multiply by 100 to convert  
        // to a percentage, and make the result an integer.  
         percents [ i ] = (int) (((double) votes [ i ] / totalvotes) * 100 );  
         }       
    // drawing area is about 200 pixels, largest vote value is 900  
    scalevotes = (double)200/ 900;  
     }  

 
  /* this method is called by the browser each time it paints the window       
   */ 
  public void paint (Graphics g)  
  {  
    Font headingfont = new Font ( " SansSerif ", Font.BOLD, 18 ) ;   
    Font linesfont = new Font ( " SansSerif", Font.ITALIC, 14 ) ;   
  
    Color beige = new Color ( 255, 255, 204 ) ;  
    Color medblue = new Color ( 102, 165, 255 ) ;  
    Color teal = new Color ( 0, 229, 181 ) ;  
    Color dkgreen = new Color ( 0, 127, 0 ) ;  
      
    // draw the question as a heading to the poll display  
    setBackground(beige);  
    g.setFont ( headingfont ) ;   
    g.setColor ( Color.black );  
    g.drawString ( questionline1, 10, 30 ) ;  
    g.drawString ( questionline2, 20, 50 ) ;  
      
    // display each answer as a line of the display  
    g.setFont ( linesfont ) ;  
  
    int start = 80 ;       // y value to start histogram  
    int line = 20 ;        //  no of pixels in each line of the histogram  
    int ystart = start;    //  for each line of histogram, the y value of upper corner  
  
    for ( int i = 0;  i < numanswers; i ++ )  
    {   
        ystart = start + (i-1) * line ;  
        g.setColor ( dkgreen ) ;  
        g.drawString ( answerlabels [ i ], 10,  ystart + 13 ) ;  
        g.setColor ( medblue ) ;  

        g.fillRect ( 300, ystart, (int) (votes [ i ] * scalevotes), 10 ) ;
 
        if ( whichdisplay.equals ("votes")) 
         { 
          g.drawString ( String.valueOf ( votes [ i ]), 520, ystart + 13) ;  
         } 
        else 
         { 
          g.drawString ( String.valueOf ( percents [ i ]) + "%", 520, ystart + 13) ;  
         } 
    }  
      
    ystart = ystart + 30;
    g.drawString ( "Total persons voting = " + String.valueOf (totalvotes), 300, ystart + 13) ;
    // draw source at the bottom  
    ystart = ystart + 50 ;  
    g.setColor ( teal ) ;  
    g.drawString ( "Source:  " + sourcelabel, 10, ystart ) ;  
  }  
}  
