/*  Dragon.java
 *  An applet to draw the traditional fractal, the dragon curve
  */
 
import java.awt.*;

public class Dragon extends java.applet.Applet
{ 
  Font f = new Font("TimesRoman", Font.PLAIN, 24);

  static final int N=8;
  static final int unit = 10;
  String moves [ ] = new String[ (int)Math.pow(2,N)-1];
  int middle, last;
  
  public void init ( )
  { 
    /*  for each i,  elements are already defined, define the middle,
    *    and copy the reverse of the first part to the end.
    */
  
     for ( int i=1; i<=N;  i ++ )
       {
         middle = (int) Math.pow(2,i-1) - 1;
         moves[middle] = "R";
         last = (int) Math.pow (2, i) - 2;
         for ( int j=0; j < middle; j++ )
         {   if ( moves[j].equals ("R"))
                 { moves [ last-j ] = "L"; }
                 else { moves [ last-j ] = "R";  }
         }
 /*       
         for ( int j = 0; j < moves.length; j++)
         { System.out.println ( moves[j] ); }
 */
     }
     }
     
  public void paint (Graphics g)
  {
    String  label = "Dragon of level " + String.valueOf(N);
    
    setBackground(Color.white);
    g.setFont(f);
    g.drawString ( label, 10, 30 );
 
/* draw the first line heading South, ending at the middle of the screen
 * at the position of currentx, currenty.  So currentx, currenty will be the
 * point at the beginning of the next line.
 */   
    int currentx = 200;
    int currenty = 200;
    String dir = "S";
    g.setColor ( Color.blue );
    g.drawLine ( currentx, currenty - unit, currentx, currenty );

    int newx=200, newy=200; 
/* for each move, based on current direction, define newx and newy
 * to be where the end of the next line should be.  Define the new
 *  direction.  Draw a line from current x,y to new x,y.
 */   
    for ( int i = 0;  i < moves.length; i ++ )
    {  
        if ( dir.equals ( "S")  && moves[i].equals ("R" ) ) 
            { newx = currentx - unit; newy = currenty; dir = "W"; }
        else {  if ( dir.equals ( "S")  && moves[i].equals ("L" ) ) 
            { newx = currentx + unit; newy = currenty; dir = "E"; }
        else {  if ( dir.equals ( "N")  && moves[i].equals ("R" ) )  
            { newx = currentx + unit; newy = currenty; dir = "E"; }
        else {  if ( dir.equals ( "N")  && moves[i].equals ("L" ) )  
            { newx = currentx - unit; newy = currenty; dir = "W"; }
        else {  if ( dir.equals ( "W")  && moves[i].equals ("R" ) )  
            { newx = currentx; newy = currenty - unit; dir = "N"; }
        else {  if ( dir.equals ( "W")  && moves[i].equals ("L" ) )  
            { newx = currentx ; newy = currenty + unit; dir = "S"; }
        else {  if ( dir.equals ( "E")  && moves[i].equals ("R" ) )  
            { newx = currentx; newy = currenty + unit; dir = "S"; }
        else {  if ( dir.equals ( "E")  && moves[i].equals ("L" ) )  
            { newx = currentx; newy = currenty - unit; dir = "N"; }
         }}}}}}}
         
        g.drawLine ( currentx, currenty, newx, newy ); 
        // reset current x,y to be new x,y to be the beginning of the line
        // at the next iteration.      
        currentx = newx;
        currenty = newy;
      }
  }
}
