/* 
 *  Pascal.java
 *  Draw Pascal triangle with mod coloring - control properties with buttons
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class Pascal extends Applet implements ActionListener
{
  // Creates the Canvas as defined in the separate class below.
  // Note that "drawing" is a variable of type Drawarea, it can
  // be used to refer to the variables and methods of the Drawarea class.
  // Saying "new Drawarea()" executes the Drawarea constructor method.

  Drawarea drawing = new Drawarea ( );

  // these panels are used in the south area to layout the controls
  Panel controls = new Panel ( ); 
  Panel first = new Panel ( );
  Panel second = new Panel ( );
  Panel third = new Panel ( ); 

  // these are the control buttons, textfields, and their labels
  Button bluez, greenz, purplez, magentaz ;
  Button bluey, greeny, purpley, magentay ; 
  Label label1, label2, label3, label4;
  TextField getrows, getmod;
  Button redraw;

  Color purple = new Color ( 127, 0, 255 );
  Color beige = new Color ( 255, 255, 204 );

  public void init ( ) 
  {
    // create and add labels and textfields in first line of controls
    label1 = new Label ( "Select color for zeros " );
    first.add ( label1 );
    bluey = new Button ( "blue" ) ;
    bluey.addActionListener ( this );
    first.add ( bluey );
    greeny = new Button ( "green" ) ;
    greeny.addActionListener ( this );
    first.add ( greeny );
    magentay = new Button ( "magenta" ) ;
    magentay.addActionListener ( this );
    first.add ( magentay );
    purpley = new Button ( "purple" ) ;
    purpley.addActionListener ( this );
    first.add ( purpley );  
 

    // create and add label and color buttons in second line of controls
    label2 = new Label ( "Select color for other numbers: " );
    second.add ( label2 );  
    bluez = new Button ( "blue" ) ;
    bluez.addActionListener ( this );
    second.add ( bluez );
    greenz = new Button ( "green" ) ;
    greenz.addActionListener ( this );
    second.add ( greenz );
    magentaz = new Button ( "magenta" ) ;
    magentaz.addActionListener ( this );
    second.add ( magentaz );
    purplez = new Button ( "purple" ) ;
    purplez.addActionListener ( this );
    second.add ( purplez );  

    // create and add the button redraw  in the third line
   label3 = new Label ( "Number of Rows (Max of 16)" );
    third.add ( label3 );  
    getrows = new TextField ( "1", 2 );
    getrows.addActionListener ( this );
    third.add ( getrows );
    label4 = new Label ( "Mod: " );
    third.add ( label4 );  
    getmod = new TextField ("2", 2 );
    getmod.addActionListener ( this );
    third.add ( getmod );
 
    redraw = new Button ( "redraw" );
    redraw.addActionListener ( this );
    third.add ( redraw );

    // set the layout of the controls to have the three rows of a grid
    // and add the three panels just set up
    controls.setLayout ( new GridLayout ( 3, 1 ));
    controls.add ( first );
    controls.add ( second );
    controls.add ( third );
    controls.setBackground ( beige );    

    // set the layout of the applet to be a border with the instance
    // of Drawarea in the center and the controls in the south
    setLayout ( new BorderLayout ( ) );
    add ( drawing, BorderLayout.CENTER );
    add ( controls, BorderLayout.SOUTH );
  }  // end of init

  /* the applet paint method just calls the paint method of the Drawarea
   * so that only that area is painted whenever the browser needs it
   */
  public void paint ( Graphics g ) 
  {
    drawing.paint ( g );
  } 

  public void actionPerformed ( ActionEvent event )
  {
   // if any color button is pressed, assign the corresponding color variable
   // of the Drawarea to be the color chosen
     if ( event.getSource ( ) == bluey )
      {  drawing.firstcolor = Color.blue;  }
    if ( event.getSource ( ) == greeny )
      {  drawing.firstcolor = Color.green;  }
    if ( event.getSource ( ) == magentay )
      {  drawing.firstcolor = Color.magenta;   }
    if ( event.getSource ( ) == purpley )
      {  drawing.firstcolor = purple;  }

     if ( event.getSource ( ) == bluez )
      {  drawing.secondcolor = Color.blue;  }
    if ( event.getSource ( ) == greenz )
      {  drawing.secondcolor = Color.green;  }
    if ( event.getSource ( ) == magentaz )
      {  drawing.secondcolor = Color.magenta;   }
    if ( event.getSource ( ) == purplez )
      {  drawing.secondcolor = purple;  }

   // if the redraw button is pressed, get the rest of the properties
   // of the Drawarea, but getting the shape string and the x,y location
   // from the textfields and assigning them to the Drawarea variables
   // Then it calls repaint, which will call the update of Drawarea,
   // which will then call the paint method.
    if ( event.getSource ( ) == redraw )
     {  
        drawing.rows = Integer.parseInt ( getrows.getText ( ).trim ( ) );
        drawing.mod = Integer.parseInt ( getmod.getText ( ).trim ( ) );
        drawing.repaint ( ) ;
      }
  }   //end of the actionPerformed method
}  // end of the applet class


/* the definition of the Drawarea class, it is a drawing Canvas
 */
class Drawarea extends Canvas
{
  // the drawing "property" variables
  Color firstcolor, secondcolor;
  int rows, mod, size, gap, x, y;  

  // the constructor method initializes the variables and other
  // properties of the canvas
  public Drawarea ( )
  {
     setBackground ( Color.black );
     firstcolor = Color.green;
     secondcolor = Color.yellow;
     rows = 1;
     mod = 2;
     size = 16;  gap = 8;
    }

  // the required paint method to call the graphics drawing methods
  public void paint ( Graphics g ) 
  {
    // create array
    int a [ ] [ ] = new int [ rows ] [ ];
    
    for ( int i = 0; i < rows; i ++ )
    {  a [ i ] = new int [ i + 1 ];
        a [ i ] [ 0 ] = 1;
        for (int j = 1; j <= i; j ++ )
        {  if ( j < i )  { a [ i ] [ j ] = ( a [ i-1 ] [ j-1 ] + a [ i-1 ] [ j ] ) % mod ; }
               else /* j = i */  { a [ i ] [ j ] = 1 ; }
          }
      }
        
      // location of drawing
     int xmiddle = getSize().width/2 - (size/2);
     int ybegin = 10;
     
     for ( int i = 0; i < rows; i++)
     {  
         x = xmiddle - i * size;
         y = ybegin + i * ( size + gap );
         
         for ( int j = 0; j <= i; j++ )
         {
             if ( a [ i ] [ j ] == 0 )  {  g.setColor ( firstcolor ); }
                 else   { g.setColor ( secondcolor ); }
             g.fillOval ( x, y, size, size ) ;
             g.setColor ( Color.black );
             g.drawString ( String.valueOf ( a [ i ] [ j ] ), x + size/2 - 3, y + size - 2 ) ;
             x = x + 2*size;
           }
        }
  }

} // end of the Drawarea class

